summaryrefslogtreecommitdiff
path: root/ACE/TAO/orbsvcs/tests/Notify/Timeout/run_test.pl
diff options
context:
space:
mode:
Diffstat (limited to 'ACE/TAO/orbsvcs/tests/Notify/Timeout/run_test.pl')
-rwxr-xr-xACE/TAO/orbsvcs/tests/Notify/Timeout/run_test.pl174
1 files changed, 174 insertions, 0 deletions
diff --git a/ACE/TAO/orbsvcs/tests/Notify/Timeout/run_test.pl b/ACE/TAO/orbsvcs/tests/Notify/Timeout/run_test.pl
new file mode 100755
index 00000000000..1f073380a9d
--- /dev/null
+++ b/ACE/TAO/orbsvcs/tests/Notify/Timeout/run_test.pl
@@ -0,0 +1,174 @@
+eval '(exit $?0)' && eval 'exec perl -S $0 ${1+"$@"}'
+ & eval 'exec perl -S $0 $argv:q'
+ if 0;
+
+# $Id$
+# -*- perl -*-
+
+use lib "$ENV{ACE_ROOT}/bin";
+use PerlACE::TestTarget;
+
+$status = 0;
+$debug_level = '0';
+
+foreach $i (@ARGV) {
+ if ($i eq '-debug') {
+ $debug_level = '10';
+ }
+}
+
+my $ns = PerlACE::TestTarget::create_target (1) || die "Create target 1 failed\n";
+my $nfs = PerlACE::TestTarget::create_target (2) || die "Create target 2 failed\n";
+my $sup = PerlACE::TestTarget::create_target (3) || die "Create target 3 failed\n";
+my $con = PerlACE::TestTarget::create_target (4) || die "Create target 4 failed\n";
+
+$sup->AddLibPath ('../lib');
+$con->AddLibPath ('../lib');
+
+PerlACE::check_privilege_group();
+
+#my $nscorbaloc = "-ORBInitRef NameService=file://$namingior";
+
+my $supiorfile = "supplier.ior";
+my $nsiorfile = "naming.ior";
+my $nfsiorfile = "notify.ior";
+
+my $ns_nsiorfile = $ns->LocalFile ($nsiorfile);
+my $nfs_nsiorfile = $nfs->LocalFile ($nsiorfile);
+my $sup_nsiorfile = $sup->LocalFile ($nsiorfile);
+my $con_nsiorfile = $con->LocalFile ($nsiorfile);
+my $nfs_nfsiorfile = $nfs->LocalFile ($nfsiorfile);
+my $sup_supiorfile = $sup->LocalFile ($supiorfile);
+my $con_supiorfile = $con->LocalFile ($supiorfile);
+$ns->DeleteFile ($nsiorfile);
+$nfs->DeleteFile ($nsiorfile);
+$sup->DeleteFile ($nsiorfile);
+$con->DeleteFile ($nsiorfile);
+$nfs->DeleteFile ($nfsiorfile);
+$sup->DeleteFile ($supiorfile);
+$con->DeleteFile ($supiorfile);
+
+my $NS = $ns->CreateProcess ("../../../Naming_Service/Naming_Service",
+ "-o $ns_nsiorfile");
+my $NFS = $ns->CreateProcess ("../../../Notify_Service/Notify_Service",
+ "-ORBInitRef NameService=file://$nfs_nsiorfile " .
+ "-IORoutput $nfs_nfsiorfile -Timeout 750");
+my $SUP = $ns->CreateProcess("Structured_Supplier",
+ "-ORBDebugLevel $debug_level ".
+ "-ORBInitRef NameService=file://$sup_nsiorfile ".
+ "-o $sup_supiorfile");
+my $CON = $ns->CreateProcess("Structured_Consumer",
+ "-ORBInitRef NameService=file://$con_nsiorfile ".
+ "-k file://$con_supiorfile");
+
+$NS_status = $NS->Spawn ();
+if ($NS_status != 0) {
+ print STDERR "ERROR: Name Service returned $NS_status\n";
+ exit 1;
+}
+
+if ($ns->WaitForFileTimed ($nsiorfile,$ns->ProcessStartWaitInterval()+$startup_timeout) == -1) {
+ print STDERR "ERROR: cannot find file <$ns_nsiorfile>\n";
+ $NS->Kill (); $NS->TimedWait (1);
+ exit 1;
+}
+
+if ($ns->GetFile ($nsiorfile) == -1) {
+ print STDERR "ERROR: cannot retrieve file <$ns_nsiorfile>\n";
+ $NS->Kill (); $NS->TimedWait (1);
+ exit 1;
+}
+if ($nfs->PutFile ($nsiorfile) == -1) {
+ print STDERR "ERROR: cannot set file <$nfs_nsiorfile>\n";
+ $NS->Kill (); $NS->TimedWait (1);
+ exit 1;
+}
+if ($sup->PutFile ($nsiorfile) == -1) {
+ print STDERR "ERROR: cannot set file <$sup_nsiorfile>\n";
+ $NS->Kill (); $NS->TimedWait (1);
+ exit 1;
+}
+if ($con->PutFile ($nsiorfile) == -1) {
+ print STDERR "ERROR: cannot set file <$con_nsiorfile>\n";
+ $NS->Kill (); $NS->TimedWait (1);
+ exit 1;
+}
+
+$NFS_status = $NFS->Spawn ();
+
+if ($NFS_status != 0) {
+ print STDERR "ERROR: Notify Service returned $NFS_status\n";
+ exit 1;
+}
+
+if ($nfs->WaitForFileTimed ($nfsiorfile,$nfs->ProcessStartWaitInterval()+$startup_timeout) == -1) {
+ print STDERR "ERROR: cannot find file <$nfs_nfsiorfile>\n";
+ $NS->Kill (); $NS->TimedWait (1);
+ $NFS->Kill (); $NFS->TimedWait (1);
+ exit 1;
+}
+
+$SUP_status = $SUP->Spawn ();
+if ($SUP_status != 0) {
+ print STDERR "ERROR: Supplier returned $SUP_status\n";
+ exit 1;
+}
+if ($sup->WaitForFileTimed ($supiorfile,$sup->ProcessStartWaitInterval()+$startup_timeout) == -1) {
+ print STDERR "ERROR: cannot find file <$sup_supiorfile>\n";
+ $SUP->Kill (); $SUP->TimedWait (1);
+ $NS->Kill (); $NS->TimedWait (1);
+ $NFS->Kill (); $NFS->TimedWait (1);
+ exit 1;
+}
+if ($sup->GetFile ($supiorfile) == -1) {
+ print STDERR "ERROR: cannot retrieve file <$sup_supiorfile>\n";
+ $SUP->Kill (); $SUP->TimedWait (1);
+ $NS->Kill (); $NS->TimedWait (1);
+ $NFS->Kill (); $NFS->TimedWait (1);
+ exit 1;
+}
+if ($con->PutFile ($supiorfile) == -1) {
+ print STDERR "ERROR: cannot set file <$con_supiorfile>\n";
+ $SUP->Kill (); $SUP->TimedWait (1);
+ $NS->Kill (); $NS->TimedWait (1);
+ $NFS->Kill (); $NFS->TimedWait (1);
+ exit 1;
+}
+
+## Wait for the supplier to create the event channel in
+## the Notify_Service and register it with the Name Service
+sleep(2);
+
+$CON_status = $CON->SpawnWaitKill ($con->ProcessStartWaitInterval()+5);
+if ($CON_status != 0) {
+ print STDERR "ERROR: Consumer returned $CON_status\n";
+ $status = 1;
+}
+
+$SUP_status = $SUP->WaitKill ($sup->ProcessStopWaitInterval());
+if ($SUP_status != 0) {
+ print STDERR "ERROR: Supplier returned $SUP_status\n";
+ $status = 1;
+}
+
+$NFS_status = $NFS->TerminateWaitKill ($nfs->ProcessStopWaitInterval());
+if ($NFS_status != 0) {
+ print STDERR "ERROR: Notification Service returned $NFS_status\n";
+ $status = 1;
+}
+
+$NS_status = $NS->TerminateWaitKill ($ns->ProcessStopWaitInterval());
+if ($NS_status != 0) {
+ print STDERR "ERROR: Name Service returned $NS_status\n";
+ $status = 1;
+}
+
+$ns->DeleteFile ($nsiorfile);
+$nfs->DeleteFile ($nsiorfile);
+$sup->DeleteFile ($nsiorfile);
+$con->DeleteFile ($nsiorfile);
+$nfs->DeleteFile ($nfsiorfile);
+$sup->DeleteFile ($supiorfile);
+$con->DeleteFile ($supiorfile);
+
+exit $status;